namespace :admin do
  desc "Promote a user to the admin level"
  task :promote_user, [:email] => [:environment] do |t, args|
    unless args.email
      puts "Which user did you want to promote?"
      next
    end

    u = User.where(email: args.email).first
    u.administrator = true
    u.save!

    puts "Successfully promoted user with email #{args.email} to admin level."
  end
  
  desc "Confirm a user's email address manually"
  task :confirm_email, [:email] => [:environment] do |t, args|
    unless args.email
      puts "Which email did you want to confirm?"
      next
    end
    
    u = User.where(email: args.email).first
    u.confirm!
    
    puts "Successfully confirmed user with email #{args.email}"
  end

  desc "Rake task to add a user to the database"
  task :add_user, [:first_name,:last_name,:password,:email] => :environment  do |task, args|
	@new_user = User.new({
		first_name: args.first_name,
		last_name: args.last_name,
		password: args.password,
		school: "ENCS",
		major: "CS",
		year: 4,
		email: args.email,
		administrator: false
	})
	@new_user.skip_confirmation!
	@new_user.save
	puts "Added new user #{args.first_name} #{args.last_name} successfully."
  end
end
