#!/bin/bash

# driver.sh - The simplest autograder we could think of. It checks
#   that students can write a C program that compiles, and then
#   executes with an exit status of zero.
#   Usage: ./driver.sh

# Compile the code
echo "Compiling hello.c"
(make clean; make)
status=$?
if [ ${status} -ne 0 ]; then
    echo "Failure: Unable to compile hello.c (return status = ${status})"
    printf '{"_presentation": "semantic",'
    printf '"stages": ["Test Results", "Summary"],'
    printf '"_scores_order": [ "Extra Credit","Correctness"],'
    printf '"Test Results": {"make": {"passed": false}},'
    printf '"Summary": {"_order": ["Tests Count", "Tests Passed", "Tests Failed", "Tests Ignored"],"Tests Count": 2, "Tests Passed": 0,"Tests Failed": 1, "Tests Ignored": 1}}\n'
    printf '{"scores": {"Extra Credit": 0, "Correctness": 0}}'
    exit
fi

# Run the code
echo "Running ./hello"
./hello
status=$?
if [ ${status} -eq 0 ]; then
    echo "Success: ./hello runs with an exit status of 0"
    echo "{\"testing\": {\"passed\": 1}}"
    printf '{"_presentation": "semantic",'
    printf '"stages": ["Summary2","Test Results", "Summary","Test Results2"],'
    printf '"_scores_order": ["Correctness", "Extra Credit"],'
    printf '"Test Results2":  {"make": { "passed": true}, "run": {"passed": true}},'
    printf '"Test Results":  {"make": { "passed": true}, "run": {"passed": true}},'
    printf '"Summary2": {"_order": ["Tests Passed", "Tests Failed", "Tests Ignored","Tests Count"],"Tests Count": 2, "Tests Passed": 2,"Tests Failed": 0, "Tests Ignored": 0},'
    printf '"Summary": {"_order": ["Tests Passed", "Tests Failed", "Tests Ignored","Tests Count"],"Tests Count": 2, "Tests Passed": 2,"Tests Failed": 0, "Tests Ignored": 0}}\n'
    printf '{"scores": {"Correctness": 100, "Extra Credit": 4}}'
else
    echo "Failure: ./hello fails or returns nonzero exit status of ${status}"
    printf '{"_presentation": "semantic",'
    printf '"stages": ["Test Results", "Summary"],'
    printf '"_scores_order": ["Correctness", "Extra Credit"],'
    printf '"Test Results":  {"_order":["run", "make"],"make": {"passed": true}, "run": {"passed": false, "hint": "it is not running"}},'
    printf '"Summary": {"_order": ["Tests Count", "Tests Passed", "Tests Failed", "Tests Ignored"],"Tests Count": 2, "Tests Passed": 1,"Tests Failed": 1, "Tests Ignored": 0}}\n'
    printf '{"scores": {"Correctness": 50, "Extra Credit": 0}}'
fi

exit

